// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic','ngCordova'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider){
	$stateProvider
		.state('inicio',{
			url: '/',
			templateUrl: 'template/inicio.html',
			controller: 'Inicio'
		})
		.state('respuesta',{
			url: '/respuesta/:numero',
			templateUrl: 'template/respuesta.html',
			controller: 'Respuesta'
		})
	$urlRouterProvider.otherwise("/");
})

.controller('Inicio', function($scope, $http, $ionicLoading, $location, $cordovaToast, $cordovaSpinnerDialog, $cordovaBarcodeScanner){
	
	$scope.titulo = 'Beep!';
	localStorage.clear();
	$scope.tarjeta= '';
	
	$scope.consultaScan = function(){
		$cordovaBarcodeScanner
      .scan()
      .then(function(barcodeData) {
        //$cordovaToast.showLongCenter(barcodeData.text);
		$cordovaSpinnerDialog.show("Espera un poco","Estamos consultado al servidor", true);
			$http.get('http://beep.dhenriquez.com/api/?bip='+barcodeData.text)//13883379
			.success(function(data){
				$cordovaSpinnerDialog.hide();
				$scope.respuesta = data;
				if(data.error==0){
					localStorage.setItem('tarjeta',data.numero);
					localStorage.setItem('estado',data.estado);
					localStorage.setItem('saldo',data.dinero);
					localStorage.setItem('fecha',data.fecha);
					localStorage.setItem('movimientos', JSON.stringify(data.movimientos));
					
					$location.path('/respuesta/'+data.numero)
				}else{
					$cordovaToast.showLongCenter(data.msg);
				}
			})
			.error(function(){
				$cordovaToast.showLongCenter('Verifica tu conexión de datos');
			})
      }, function(error) {
        $cordovaToast.showLongCenter('Ha ocurrido un error (quizás inexplicable).');
      });
	}
	$scope.consulta = function(){
		if(this.tarjeta==''){
			$cordovaToast.showLongCenter('Nº Tarjeta vacío');
		}else{
			//$ionicLoading.show({template:'<i class="icon ion-loading-c"></i> Consultando'});
			$cordovaSpinnerDialog.show("Espera un poco","Estamos consultado al servidor", true);
			$http.get('http://beep.dhenriquez.com/api/?bip='+this.tarjeta)//13883379
			.success(function(data){
				$cordovaSpinnerDialog.hide();
				$scope.respuesta = data;
				if(data.error==0){
					localStorage.setItem('tarjeta',data.numero);
					localStorage.setItem('estado',data.estado);
					localStorage.setItem('saldo',data.dinero);
					localStorage.setItem('fecha',data.fecha);
					localStorage.setItem('movimientos', JSON.stringify(data.movimientos));
					
					$location.path('/respuesta/'+data.numero)
				}else{
					$cordovaToast.showLongCenter(data.msg);
				}
			})
			.error(function(){
				$cordovaToast.showLongCenter('Verifica tu conexión de datos');
			})
		}
	}
})

.controller('Respuesta', function($scope, $stateParams, $cordovaToast, $cordovaSpinnerDialog){
	$scope.titulo = "Bip!: "+$stateParams.numero;
	
	$scope.tarjeta	= localStorage.getItem('movimientos');
	$scope.estado	= localStorage.getItem('estado');
	$scope.saldo	= localStorage.getItem('saldo');
	$scope.fecha	= localStorage.getItem('fecha');
	var json = localStorage.getItem('movimientos');
	obj = JSON.parse(json);
	$scope.datos=obj;
				
})